- [JabyEngine](#jabyengine)
  - [About](#about)
  - [Podman](#podman)
  - [How to build](#how-to-build)
    - [Building `JabyEngine` (without VSCode)](#building-jabyengine-without-vscode)
    - [Building support library (without VSCode)](#building-support-library-without-vscode)
      - [`FontWriter` (without VSCode)](#fontwriter-without-vscode)
    - [Building `PoolBox` (without VSCode)](#building-poolbox-without-vscode)
- [Media creators](#media-creators)
  - [JabyEngine](#jabyengine-1)
  - [PoolBox](#poolbox)
- [Special thanks](#special-thanks)
- [TODO before commit](#todo-before-commit)

# JabyEngine
## About
JabyEngine is my personal attempt to eventually make my own PS1 game from "ground up". Originally I didn't indented to release this code publicly but recently I decided to give it a try. If you read this, thank you! 

## Podman
* `sudo apt install podman`
* `podman build -t jaby_engine <Folder of Dockerfile>`
* `podman images`: lists all images
* `podman image rm <COMMIT ID>`: removes an image
* `podman run -it <COMMIT ID> /bin/bash`: runs bash and interactive
* `podman run --rm <-v <local_folder>:<absolute docker_folder> <-e ENV_VAR=VALUE>  jaby_engine`: clean up after run
* `podman image tree <TAG/ID>`: lists usefull information
* `podman run --rm -it -v ${JABY_ENGINE_PATH}:${JABY_ENGINE_PATH} jaby_engine /bin/bash` maybe a good idea...?
* `${JABY_ENGINE_PATH}/scripts/podman_jaby_engine.sh make all BUILD_PROFILE=release PSX_TV_FORMAT=PAL CUSTOM_CONFIG=`

## How to build
JabyEngine relies on linux to be build. For Windows users it uses `wsl` instead but support for it might get dropped during further development.

The following environment variables should be set:
* `JABY_ENGINE_PATH`: The path to the root folder of this repo
* `PSX_LICENSE_PATH`: The path to a folder containing the PS1 licenses for generating a CD.
  
Additionally you can also specify the following optional environment variables:
* `JABY_ENGINE_NO_DOCKER`: Turns off usage of `podman` for build. This is only recommended for specific development.

### Building `JabyEngine` (without VSCode)
`make` requires the following values to be passed:
* `BUILD_PROFILE`: `debug`/`release` 
* `PSX_TV_FORMAT`: `PAL`/`NTSC`
* `CUSTOM_CONFIG`: Empty or folder name under `./config`

### Building support library (without VSCode)
These projects shall eventually turn into useful extensions for the engine. So far they are more tests then proper code. However `PoolBox` is depended on `FontWriter`.

#### `FontWriter` (without VSCode)
`make` requires the following values to be passed:
* `BUILD_PROFILE`: `debug`/`release`

### Building `PoolBox` (without VSCode)
`PoolBox` is the one and only example project so far.
`make` requires the following values to be passed:
* `BUILD_PROFILE`: `debug`/`release` 
* `REGION`: `SCEE`/`SCEA`/`SCEI`
* `CUSTOM_CONFIG`: Empty or folder name under `$(JABY_ENGINE_PATH)/config`


# Media creators
## JabyEngine
| Art                                                             | Author                                                     |
|-----------------------------------------------------------------|------------------------------------------------------------|
| `ressources\Splash_ntsc.png` <br/> `ressources\Splash_ntsc.png` | Niuka                                                      |
| `bin/extern/32BIT.TMD`                                          | http://psx.arthus.net/homebrew/assets/boot_logos/32BIT.TMD |

## PoolBox
| Art                                                             | Author      |
|-----------------------------------------------------------------|-------------|
| `examples\PoolBox\assets\AllTheJaby.png`                        | Niuka       |
| `examples\PoolBox\assets\IconTexture.png`                       | Charlie Nax |
| `examples\PoolBox\assets\Paco.png`                              | Paco        |

| Music                                                                     | Author                                |
|---------------------------------------------------------------------------|---------------------------------------|
| `examples\PoolBox\assets\audio\apple.wav`                                 | ???                                   |
| `examples\PoolBox\assets\audio\blubb-mono.wav`                            | ???                                   |
| `examples\PoolBox\assets\audio\Evacuation_cdda.wav`                       | Cody the white tiger                  |
| `examples\PoolBox\assets\audio\Friendship_samp.wav`                       | From Dragon Quest VII                 |
| `examples\PoolBox\assets\audio\jlbrock44_Three_Kings_Funk_cdda_ready.wav` | `Three Kings Funk` by spinningmerkaba |
| `examples\PoolBox\assets\audio\OnMyOwn_BailBonds.mp3`                     | `On My Own` by Bail Bonds             |

# Special thanks
* Cody the white tiger
* Nicolas Noble
* Pyravia
* Sickle

# TODO before commit
* Remove `wslpath`
* Double check documentation